﻿using Avalonia.Controls;
using AvaloniaApplicationBase.Models;
using AvaloniaApplicationBase.Views;
using Microsoft.EntityFrameworkCore;
using ReactiveUI;
using System.Collections.Generic;
using System.Linq;

namespace AvaloniaApplicationBase.ViewModels
{
    public class MainWindowViewModel : ViewModelBase
    {
        public static CatBaseContext myConnection = new CatBaseContext(); // для подключения БД

        UserControl us = new ShowCatsPage(); // сюда помещаются страницы (по умолчанию будет показана страница с просмотром информации)
        
        // свойство для изменения страниц
        public UserControl US 
        { 
            get => us; 
            set => this.RaiseAndSetIfChanged(ref us, value); 
        }

        ShowCatsPageViewModel showCatsVM = new ShowCatsPageViewModel(myConnection); // объект VM с кодом для просмотром информации о котах
        
        // свойсво для изменения выше созданной переменной
        public ShowCatsPageViewModel ShowCatsVM 
        { 
            get => showCatsVM; 
            set => showCatsVM = value; 
        }
        

        AddCatPageViewModel addCatVM = new AddCatPageViewModel(); // объект для связи со страницей с добавлением кота
        public AddCatPageViewModel AddCatVM { get => addCatVM; set => addCatVM = value; }   // свойсво для изменения выше созданной переменной

        public void NewCatPage() // переход на страницу с добавлением нового кота
        {
            US = new AddCatPage();
        }

        
    }
}