using System;
using System.Collections.Generic;
using System.Linq;
using AvaloniaApplicationBase.Models;
using Microsoft.EntityFrameworkCore;
using ReactiveUI;

namespace AvaloniaApplicationBase.ViewModels
{
	public class ShowCatsPageViewModel : ReactiveObject
	{
        CatBaseContext myConnection;
        private List<CatTable> ct;

        public ShowCatsPageViewModel(CatBaseContext myConnection)
        {
            this.myConnection = myConnection;
            CT = myConnection.CatTables.Include(x => x.GenderNavigation).Include(x => x.TraitCatTables).ThenInclude(x => x.IdTraitNavigation).ToList();

        }

        // Include -  ,      
        // ThenInclude -    ,       (    moodle)

        public List<CatTable> CT { get => ct; set => this.RaiseAndSetIfChanged(ref ct,value); }

        //    
        public List<string> OrdersName => new List<string>() { " ", " " };

        public string OrderByName 
        { 
            get => orderByName;
            set
            {
                orderByName = value;
                AllFilters();
            }
        }

        string orderByName = " ";


        //   
        public List<string> GenderList
        {
            get
            {
                List<string> genders = new List<string>() { "" };
                genders.AddRange(myConnection.GenderTables.Select(x => x.Gender).ToList());
                return genders;
            }
        }

        public string SelectedGender 
        { 
            get => selectedGender;
            set
            {
                selectedGender = value;
                AllFilters();
            }
        }

        

        string selectedGender = "";

        //   
        string nameFind;
        public string NameFind
        {
            get => nameFind;
            set
            {
                nameFind = value;
                AllFilters();
            }
        }

        void AllFilters()
        {
            CT = myConnection.CatTables.Include(x => x.GenderNavigation).Include(x => x.TraitCatTables).ThenInclude(x => x.IdTraitNavigation).ToList();
            switch (orderByName)
            {
                case " ":
                    CT = CT.OrderBy(x=>x.Name).ToList();
                    break;
                case " ":
                    CT = CT.OrderByDescending(x=>x.Name).ToList(); 
                    break;
            }

            if (selectedGender!="")
            {
                CT = CT.Where(x=>x.GenderNavigation.Gender==selectedGender).ToList();
            }

            if (!string.IsNullOrWhiteSpace(nameFind))
            {
                CT = CT.Where(x=>x.Name.ToLower().Contains(nameFind.ToLower())).ToList();
            }
        }

    }
}